---
title: 'HTML attribute: multiple'
slug: Web/HTML/Attributes/multiple
tags:
  - Attribute
  - Attributes
  - Constraint validation
  - HTML
---
<p>{{HTMLSidebar}}</p>

<p>The Boolean <strong><code>multiple</code></strong> attribute, if set, means the form control accepts one or more values. Valid for the {{HTMLElement("input/email", "email")}} and {{HTMLElement("input/file", "file")}} input types and the {{HTMLElement("select")}}, the manner by which the user opts for multiple values depends on the form control.</p>

<p>Depending on the type, the form control may have a different appearance if the <code>multiple</code> attribute is set. For the file input type, the native messaging the browser provides differs. In Firefox, the file input reads "No files selected" when the attribute is present and "No file selected" when not, when no files are selected. Most browsers displaying a scrolling list box for a {{HTMLElement("select")}} control with the <code>multiple</code> attribute set versus a single line dropdown when the attribute is ommitted. The {{HTMLElement("input/email", "email")}} input displays the same, but will match the {{cssxref(':invalid')}} pseudo-class if more than one comma-separated email address is included if the attribute is not present.</p>

<p>When <code>multiple</code> is set on the {{HTMLElement("input/email", "email")}} input type, the user can inlclude zero (if not also <code><a href="/en-US/docs/Web/HTML/Attributes/required">required</a></code>), one or more comma-separated email addresses.</p>

<pre class="brush: html notranslate">&lt;input type="email" <strong>multiple</strong> name="emails" id="emails"&gt;</pre>

<p>If and only if the <code>multiple</code> attribute is specified, the value can be a list of properly-formed comma-separated e-mail addresses. Any trailing and leading whitespace is removed from each address in the list.</p>

<p>When <code>multiple</code> is set on the {{HTMLElement("input/file", "file")}} input type, the user can select one or more files. The user can choose multiple files from the file picker in any way that their chosen platform allows (e.g. by holding down <kbd>Shift</kbd> or <kbd>Control</kbd>, and then clicking).</p>

<pre class="brush: html notranslate">&lt;input type="file" <strong>multiple</strong> name="uploads" id="uploads"&gt;</pre>

<p>When the attribute is omitted, the user can only select a single file per <code>&lt;input&gt;</code>.</p>

<p>The <code>multiple</code> attribute on the {{HTMLElement("select")}} element represents a control for selecting zero or more options from the list of options. Otherwise, the {{HTMLElement("select")}} element represents a control for selecting a single {{HTMLElement("option")}} from the list of options.</p>

<pre class="brush: html notranslate">&lt;select multiple name="drawfs" id="drawfs"&gt;
  &lt;option&gt;Grumpy&lt;/option&gt;
  &lt;option&gt;Happy&lt;/option&gt;
  &lt;option&gt;Sleepy&lt;/option&gt;
  &lt;option&gt;Bashful&lt;/option&gt;
  &lt;option&gt;Sneezy&lt;/option&gt;
  &lt;option&gt;Dopey&lt;/option&gt;
  &lt;option&gt;Doc&lt;/option&gt;
&lt;/select&gt;</pre>

<p>When <code>multiple</code> is specified, most browsers will show a scrolling list box instead of a single line dropdown.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Provide instructions to help users understand how to complete the form and use individual form controls. Indicate any required and optional input, data formats, and other relevant information. When using the <code>multiple</code> attribute, inform the user that multiple values are allowed and provide directions on how to provide multiple values, such as "separate email addresses with a comma."</p>

<p>Setting <code><a href="/en-US/docs/Web/HTML/Attributes/size">size</a>="1"</code> on a multiple select can make it appear as a single select in some browsers, but then it doesn't expand on focus, harming usability. Don't do that. If you do change the appearance of a select, and even if you don't, make sure to inform the user that more than one option can be selected by another method.</p>

<h2 id="Examples">Examples</h2>

<h3 id="email_input">email input</h3>

<pre class="brush: html notranslate">&lt;label for="emails"&gt;Who do you want to email?&lt;/label&gt;
&lt;input type="email" multiple name="emails" id="emails" list="drawfemails" required size="64"&gt;

&lt;datalist id="drawfemails"&gt;
  &lt;option value="grumpy@woodworkers.com"&gt;Grumpy&lt;/option&gt;
  &lt;option value="happy@woodworkers.com"&gt;Happy&lt;/option&gt;
  &lt;option value="sleepy@woodworkers.com"&gt;Sleepy&lt;/option&gt;
  &lt;option value="bashful@woodworkers.com"&gt;Bashful&lt;/option&gt;
  &lt;option value="sneezy@woodworkers.com"&gt;Sneezy&lt;/option&gt;
  &lt;option value="dopey@woodworkers.com"&gt;Dopey&lt;/option&gt;
  &lt;option value="doc@woodworkers.com"&gt;Doc&lt;/option&gt;
&lt;/datalist&gt;</pre>

<div class="hidden">
<pre class="brush: css notranslate">input:invalid {border: red solid 3px;}</pre>
</div>

<p>If and only if the <code>multiple</code> attribute is specified, the value can be a list of properly-formed comma-separated e-mail addresses. Any trailing and leading whitespace is removed from each address in the list. If the <code><a href="/en-US/docs/Web/HTML/Attributes/required">required</a></code> attribute is present, at least one email address is required.</p>

<p>Some browsers support the appearance of the <code><a href="/en-US/docs/Web/HTML/Attributes/list">list</a></code> of options from the associated {{htmlelement('datalist')}} for subsequent email addresses when <code>multiple</code> is present. Others do not.</p>

<p>{{EmbedLiveSample("email_input", 600, 80) }}</p>

<h3 id="file_input">file input</h3>

<p>When <code>multiple</code> is set on the {{HTMLElement("input/file", "file")}} input type, the user can select one or more files:</p>

<pre class="brush: html notranslate">&lt;form method="post" enctype="multipart/form-data"&gt;
  &lt;p&gt;
    &lt;label for="uploads"&gt;
       Choose the images you want to upload:
    &lt;/label&gt;
    &lt;input type="file" id="uploads" name="uploads" accept=".jpg, .jpeg, .png, .svg, .gif" multiple&gt;
  &lt;/p&gt;
  &lt;p&gt;
    &lt;label for="text"&gt;Pick a text file to upload: &lt;/label&gt;
    &lt;input type="file" id="text" name="text" accept=".txt"&gt;
 &lt;/p&gt;
  &lt;p&gt;
    &lt;input type="submit" value="Submit"&gt;
  &lt;/p&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample("file_input", 600, 80) }}</p>

<p>Note the difference in appearance between the example with <code>multiple</code> set and the other <code>file</code> input without.</p>

<p>When the form is submitted,had we used <code><a href="/en-US/docs/Web/HTML/Element/form">method="get"</a></code> each selected file's name would have been added to URL parameters as<code>?uploads=img1.jpg&amp;uploads=img2.svg</code>. However, since we are sumbitting <a href="/en-US/docs/Web/API/XMLHttpRequest/multipart">multipart</a> form data, we much use post. See the {{htmlelement('form')}} element  and <a href="/en-US/docs/Learn/HTML/Forms/Sending_and_retrieving_form_data#The_method_attribute">sending form data</a> for more information.</p>

<h3 id="select">select</h3>

<p>The <code>multiple</code> attribute on the {{HTMLElement("select")}} element represents a control for selecting zero or more options from the list of options. Otherwise, the {{HTMLElement("select")}} element represents a control for selecting a single {{HTMLElement("option")}} from the list of options. The control generally has a different appearance based on the presence of the multiple attribute, with most browsers displaying a scrolling list box instead of a single line dropdown when the attribute is present.</p>

<pre class="brush: html notranslate">&lt;form method="get" action="#"&gt;
&lt;p&gt;
 &lt;label for="dwarfs"&gt;Select the woodsmen you like:&lt;/label&gt;
  &lt;select multiple name="drawfs" id="drawfs"&gt;
    &lt;option&gt;grumpy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;happy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;sleepy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;bashful@woodworkers.com&lt;/option&gt;
    &lt;option&gt;sneezy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;dopey@woodworkers.com&lt;/option&gt;
    &lt;option&gt;doc@woodworkers.com&lt;/option&gt;
  &lt;/select&gt;
&lt;/p&gt;
&lt;p&gt;
 &lt;label for="favoriteOnly"&gt;Select your favorite:&lt;/label&gt;
  &lt;select name="favoriteOnly" id="favoriteOnly"&gt;
    &lt;option&gt;grumpy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;happy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;sleepy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;bashful@woodworkers.com&lt;/option&gt;
    &lt;option&gt;sneezy@woodworkers.com&lt;/option&gt;
    &lt;option&gt;dopey@woodworkers.com&lt;/option&gt;
    &lt;option&gt;doc@woodworkers.com&lt;/option&gt;
  &lt;/select&gt;
&lt;/p&gt;
&lt;p&gt;
  &lt;input type="submit" value="Submit"&gt;
&lt;/p&gt;
&lt;/form&gt;</pre>

<p>{{EmbedLiveSample("select", 600, 120) }}</p>

<p>Note the difference in appearance between the two form controls.</p>

<pre class="brush: css notranslate">/* uncomment this CSS to make the multiple the same height as the single */

/*
select[multiple] {
  height: 1.5em;
  vertical-align: top;
}
select[multiple]:focus,
select[multiple]:active {
  height: auto;
}
*/</pre>

<p>There are a few ways to select multiple options in a <code>&lt;select&gt;</code> element with a <code>multiple</code> attribute. Depending on the operating system, mouse users can hold the <kbd>Ctrl</kbd>, <kbd>Command</kbd>, or <kbd>Shift</kbd> keys and then click multiple options to select/deselect them. Keyboard users can select multiple contiguous items by focusing on the <code>&lt;select&gt;</code> element, selecting an item at the top or bottom of the range they want to select using the <kbd>Up</kbd> and <kbd>Down</kbd> cursor keys to go up and down the options. The selection of non-contiguous is not as well supported: items should be able to be selected and deselected by pressing <kbd>Space</kbd> , but support varies between browsers.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'input.html#attr-input-multiple', 'multiple attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'input.html#attr-input-multiple', 'multiple attribute')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{htmlelement('input')}}</li>
 <li>{{htmlelement('select')}}</li>
 <li><a href="/en-US/docs/Web/HTML/Element/input/email#Allowing_multiple_e-mail_addresses">Allowing multiple e-mail addresses</a></li>
</ul>
